/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-hrpsys-ros-bridge-1.2.4-0oneiric-20140912-0413/msg/OpenHRP_AutoBalancerService_AutoBalancerParam.msg
 *
 */


#ifndef HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_AUTOBALANCERPARAM_H
#define HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_AUTOBALANCERPARAM_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Float64MultiArray.h>

namespace hrpsys_ros_bridge
{
template <class ContainerAllocator>
struct OpenHRP_AutoBalancerService_AutoBalancerParam_
{
  typedef OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> Type;

  OpenHRP_AutoBalancerService_AutoBalancerParam_()
    : default_zmp_offsets()
    , move_base_gain(0.0)  {
    }
  OpenHRP_AutoBalancerService_AutoBalancerParam_(const ContainerAllocator& _alloc)
    : default_zmp_offsets(_alloc)
    , move_base_gain(0.0)  {
    }



   typedef  ::std_msgs::Float64MultiArray_<ContainerAllocator>  _default_zmp_offsets_type;
  _default_zmp_offsets_type default_zmp_offsets;

   typedef double _move_base_gain_type;
  _move_base_gain_type move_base_gain;




  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct OpenHRP_AutoBalancerService_AutoBalancerParam_

typedef ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<std::allocator<void> > OpenHRP_AutoBalancerService_AutoBalancerParam;

typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam > OpenHRP_AutoBalancerService_AutoBalancerParamPtr;
typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam const> OpenHRP_AutoBalancerService_AutoBalancerParamConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace hrpsys_ros_bridge

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'hrpsys_ros_bridge': ['/tmp/buildd/ros-groovy-hrpsys-ros-bridge-1.2.4-0oneiric-20140912-0413/msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bb8273a34fdc60819ba7ee5810d03dc4";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xbb8273a34fdc6081ULL;
  static const uint64_t static_value2 = 0x9ba7ee5810d03dc4ULL;
};

template<class ContainerAllocator>
struct DataType< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "hrpsys_ros_bridge/OpenHRP_AutoBalancerService_AutoBalancerParam";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "std_msgs/Float64MultiArray default_zmp_offsets\n\
float64 move_base_gain\n\
\n\
================================================================================\n\
MSG: std_msgs/Float64MultiArray\n\
# Please look at the MultiArrayLayout message definition for\n\
# documentation on all multiarrays.\n\
\n\
MultiArrayLayout  layout        # specification of data layout\n\
float64[]         data          # array of data\n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/MultiArrayLayout\n\
# The multiarray declares a generic multi-dimensional array of a\n\
# particular data type.  Dimensions are ordered from outer most\n\
# to inner most.\n\
\n\
MultiArrayDimension[] dim # Array of dimension properties\n\
uint32 data_offset        # padding bytes at front of data\n\
\n\
# Accessors should ALWAYS be written in terms of dimension stride\n\
# and specified outer-most dimension first.\n\
# \n\
# multiarray(i,j,k) = data[data_offset + dim_stride[1]*i + dim_stride[2]*j + k]\n\
#\n\
# A standard, 3-channel 640x480 image with interleaved color channels\n\
# would be specified as:\n\
#\n\
# dim[0].label  = \"height\"\n\
# dim[0].size   = 480\n\
# dim[0].stride = 3*640*480 = 921600  (note dim[0] stride is just size of image)\n\
# dim[1].label  = \"width\"\n\
# dim[1].size   = 640\n\
# dim[1].stride = 3*640 = 1920\n\
# dim[2].label  = \"channel\"\n\
# dim[2].size   = 3\n\
# dim[2].stride = 3\n\
#\n\
# multiarray(i,j,k) refers to the ith row, jth column, and kth channel.\n\
================================================================================\n\
MSG: std_msgs/MultiArrayDimension\n\
string label   # label of given dimension\n\
uint32 size    # size of given dimension (in type units)\n\
uint32 stride  # stride of given dimension\n\
";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.default_zmp_offsets);
      stream.next(m.move_base_gain);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct OpenHRP_AutoBalancerService_AutoBalancerParam_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_AutoBalancerParam_<ContainerAllocator>& v)
  {
    s << indent << "default_zmp_offsets: ";
    s << std::endl;
    Printer< ::std_msgs::Float64MultiArray_<ContainerAllocator> >::stream(s, indent + "  ", v.default_zmp_offsets);
    s << indent << "move_base_gain: ";
    Printer<double>::stream(s, indent + "  ", v.move_base_gain);
  }
};

} // namespace message_operations
} // namespace ros

#endif // HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_AUTOBALANCERPARAM_H
